default:
  tags:
    - prod

stages:
  - build
  - deploy

build:
  stage: build
  image: docker:19-dind
  services:
    - docker:19-dind
  variables:
    DOCKER_HOST: tcp://localhost:2376/
    DOCKER_TLS_CERTDIR: "/certs"
    DOCKER_TLS_VERIFY: 1
    DOCKER_CERT_PATH: "$DOCKER_TLS_CERTDIR/client"
  before_script:
    - until docker info; do sleep 1; done
    - docker login -u $REGISTRY_USER -p $REGISTRY_PASSWORD
  script:
    - docker build 
      --network host 
      -t riptide01/$CI_PROJECT_NAME:latest .
    - docker push riptide01/$CI_PROJECT_NAME:latest
  only:
    changes:
    - Dockerfile
    - .gitlab-ci.yml

deploy:
  stage: deploy
  image: centosadmin/kubernetes-helm:3.6.3
  script:
    - kubectl config set-cluster k8s --insecure-skip-tls-verify=true --server=$K8S_PROD_API_URL
    - kubectl config set-credentials ci --token=$K8S_PROD_CI_TOKEN
    - kubectl config set-context ci --cluster=k8s --user=ci
    - kubectl config use-context ci
    - helm upgrade --install $CI_PROJECT_NAME helm
        -f helm/values.yaml
        --debug
        --atomic
        --timeout 600s
        --namespace $CI_PROJECT_NAME
  when: manual